=== debian/control ===
Source: ros-noetic-knowledge-representation
Section: misc
Priority: optional
Maintainer: Nick Walker <nswalker@cs.washington.edu>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libpqxx-6.4, libpqxx-dev, postgresql, postgresql-contrib, python3-dev, python3-setuptools, ros-noetic-catkin, ros-noetic-roslint, ros-noetic-rosunit <!nocheck>
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-knowledge-representation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libpqxx-6.4, libpqxx-dev, postgresql, postgresql-contrib, python3-dev, python3-pil
Description: APIs for storing and querying information about the world.
 Provides C++ and Python API's to make getting facts in and out easy (while still exposing a full SQL interface). Supports PostgreSQL and MySQL backends.
